package com.lightinit.hsdataportal.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BusinessMonitoringExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BusinessMonitoringExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeIsNull() {
            addCriterion("monitoring_type is null");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeIsNotNull() {
            addCriterion("monitoring_type is not null");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeEqualTo(String value) {
            addCriterion("monitoring_type =", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeNotEqualTo(String value) {
            addCriterion("monitoring_type <>", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeGreaterThan(String value) {
            addCriterion("monitoring_type >", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeGreaterThanOrEqualTo(String value) {
            addCriterion("monitoring_type >=", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeLessThan(String value) {
            addCriterion("monitoring_type <", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeLessThanOrEqualTo(String value) {
            addCriterion("monitoring_type <=", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeLike(String value) {
            addCriterion("monitoring_type like", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeNotLike(String value) {
            addCriterion("monitoring_type not like", value, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeIn(List<String> values) {
            addCriterion("monitoring_type in", values, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeNotIn(List<String> values) {
            addCriterion("monitoring_type not in", values, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeBetween(String value1, String value2) {
            addCriterion("monitoring_type between", value1, value2, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andMonitoringTypeNotBetween(String value1, String value2) {
            addCriterion("monitoring_type not between", value1, value2, "monitoringType");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNull() {
            addCriterion("start_time is null");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNotNull() {
            addCriterion("start_time is not null");
            return (Criteria) this;
        }

        public Criteria andStartTimeEqualTo(Date value) {
            addCriterion("start_time =", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotEqualTo(Date value) {
            addCriterion("start_time <>", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThan(Date value) {
            addCriterion("start_time >", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("start_time >=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThan(Date value) {
            addCriterion("start_time <", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThanOrEqualTo(Date value) {
            addCriterion("start_time <=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIn(List<Date> values) {
            addCriterion("start_time in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotIn(List<Date> values) {
            addCriterion("start_time not in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeBetween(Date value1, Date value2) {
            addCriterion("start_time between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotBetween(Date value1, Date value2) {
            addCriterion("start_time not between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNull() {
            addCriterion("end_time is null");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNotNull() {
            addCriterion("end_time is not null");
            return (Criteria) this;
        }

        public Criteria andEndTimeEqualTo(Date value) {
            addCriterion("end_time =", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotEqualTo(Date value) {
            addCriterion("end_time <>", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThan(Date value) {
            addCriterion("end_time >", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("end_time >=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThan(Date value) {
            addCriterion("end_time <", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("end_time <=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIn(List<Date> values) {
            addCriterion("end_time in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotIn(List<Date> values) {
            addCriterion("end_time not in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeBetween(Date value1, Date value2) {
            addCriterion("end_time between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("end_time not between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleIsNull() {
            addCriterion("monitoring_cycle is null");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleIsNotNull() {
            addCriterion("monitoring_cycle is not null");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleEqualTo(Integer value) {
            addCriterion("monitoring_cycle =", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleNotEqualTo(Integer value) {
            addCriterion("monitoring_cycle <>", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleGreaterThan(Integer value) {
            addCriterion("monitoring_cycle >", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleGreaterThanOrEqualTo(Integer value) {
            addCriterion("monitoring_cycle >=", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleLessThan(Integer value) {
            addCriterion("monitoring_cycle <", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleLessThanOrEqualTo(Integer value) {
            addCriterion("monitoring_cycle <=", value, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleIn(List<Integer> values) {
            addCriterion("monitoring_cycle in", values, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleNotIn(List<Integer> values) {
            addCriterion("monitoring_cycle not in", values, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleBetween(Integer value1, Integer value2) {
            addCriterion("monitoring_cycle between", value1, value2, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andMonitoringCycleNotBetween(Integer value1, Integer value2) {
            addCriterion("monitoring_cycle not between", value1, value2, "monitoringCycle");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1IsNull() {
            addCriterion("threshold_value1 is null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1IsNotNull() {
            addCriterion("threshold_value1 is not null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1EqualTo(Integer value) {
            addCriterion("threshold_value1 =", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1NotEqualTo(Integer value) {
            addCriterion("threshold_value1 <>", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1GreaterThan(Integer value) {
            addCriterion("threshold_value1 >", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1GreaterThanOrEqualTo(Integer value) {
            addCriterion("threshold_value1 >=", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1LessThan(Integer value) {
            addCriterion("threshold_value1 <", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1LessThanOrEqualTo(Integer value) {
            addCriterion("threshold_value1 <=", value, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1In(List<Integer> values) {
            addCriterion("threshold_value1 in", values, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1NotIn(List<Integer> values) {
            addCriterion("threshold_value1 not in", values, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1Between(Integer value1, Integer value2) {
            addCriterion("threshold_value1 between", value1, value2, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue1NotBetween(Integer value1, Integer value2) {
            addCriterion("threshold_value1 not between", value1, value2, "thresholdValue1");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2IsNull() {
            addCriterion("threshold_value2 is null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2IsNotNull() {
            addCriterion("threshold_value2 is not null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2EqualTo(Integer value) {
            addCriterion("threshold_value2 =", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2NotEqualTo(Integer value) {
            addCriterion("threshold_value2 <>", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2GreaterThan(Integer value) {
            addCriterion("threshold_value2 >", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2GreaterThanOrEqualTo(Integer value) {
            addCriterion("threshold_value2 >=", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2LessThan(Integer value) {
            addCriterion("threshold_value2 <", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2LessThanOrEqualTo(Integer value) {
            addCriterion("threshold_value2 <=", value, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2In(List<Integer> values) {
            addCriterion("threshold_value2 in", values, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2NotIn(List<Integer> values) {
            addCriterion("threshold_value2 not in", values, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2Between(Integer value1, Integer value2) {
            addCriterion("threshold_value2 between", value1, value2, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue2NotBetween(Integer value1, Integer value2) {
            addCriterion("threshold_value2 not between", value1, value2, "thresholdValue2");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3IsNull() {
            addCriterion("threshold_value3 is null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3IsNotNull() {
            addCriterion("threshold_value3 is not null");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3EqualTo(Integer value) {
            addCriterion("threshold_value3 =", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3NotEqualTo(Integer value) {
            addCriterion("threshold_value3 <>", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3GreaterThan(Integer value) {
            addCriterion("threshold_value3 >", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3GreaterThanOrEqualTo(Integer value) {
            addCriterion("threshold_value3 >=", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3LessThan(Integer value) {
            addCriterion("threshold_value3 <", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3LessThanOrEqualTo(Integer value) {
            addCriterion("threshold_value3 <=", value, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3In(List<Integer> values) {
            addCriterion("threshold_value3 in", values, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3NotIn(List<Integer> values) {
            addCriterion("threshold_value3 not in", values, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3Between(Integer value1, Integer value2) {
            addCriterion("threshold_value3 between", value1, value2, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andThresholdValue3NotBetween(Integer value1, Integer value2) {
            addCriterion("threshold_value3 not between", value1, value2, "thresholdValue3");
            return (Criteria) this;
        }

        public Criteria andAlertMethodIsNull() {
            addCriterion("alert_method is null");
            return (Criteria) this;
        }

        public Criteria andAlertMethodIsNotNull() {
            addCriterion("alert_method is not null");
            return (Criteria) this;
        }

        public Criteria andAlertMethodEqualTo(String value) {
            addCriterion("alert_method =", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodNotEqualTo(String value) {
            addCriterion("alert_method <>", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodGreaterThan(String value) {
            addCriterion("alert_method >", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodGreaterThanOrEqualTo(String value) {
            addCriterion("alert_method >=", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodLessThan(String value) {
            addCriterion("alert_method <", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodLessThanOrEqualTo(String value) {
            addCriterion("alert_method <=", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodLike(String value) {
            addCriterion("alert_method like", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodNotLike(String value) {
            addCriterion("alert_method not like", value, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodIn(List<String> values) {
            addCriterion("alert_method in", values, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodNotIn(List<String> values) {
            addCriterion("alert_method not in", values, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodBetween(String value1, String value2) {
            addCriterion("alert_method between", value1, value2, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertMethodNotBetween(String value1, String value2) {
            addCriterion("alert_method not between", value1, value2, "alertMethod");
            return (Criteria) this;
        }

        public Criteria andAlertTimeIsNull() {
            addCriterion("alert_time is null");
            return (Criteria) this;
        }

        public Criteria andAlertTimeIsNotNull() {
            addCriterion("alert_time is not null");
            return (Criteria) this;
        }

        public Criteria andAlertTimeEqualTo(Date value) {
            addCriterion("alert_time =", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeNotEqualTo(Date value) {
            addCriterion("alert_time <>", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeGreaterThan(Date value) {
            addCriterion("alert_time >", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("alert_time >=", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeLessThan(Date value) {
            addCriterion("alert_time <", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeLessThanOrEqualTo(Date value) {
            addCriterion("alert_time <=", value, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeIn(List<Date> values) {
            addCriterion("alert_time in", values, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeNotIn(List<Date> values) {
            addCriterion("alert_time not in", values, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeBetween(Date value1, Date value2) {
            addCriterion("alert_time between", value1, value2, "alertTime");
            return (Criteria) this;
        }

        public Criteria andAlertTimeNotBetween(Date value1, Date value2) {
            addCriterion("alert_time not between", value1, value2, "alertTime");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}